%!octave 
%
%    Hamming ANN based classifier
%
%       OS : GNU/Linux 3.12.0-1-ARCH 
% COMPILER : GNU Octave, version 3.8.0
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: ann_run.m,v 1.2 2014/05/26 08:59:33 mechanoid Exp mechanoid $

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function retval=ann_run(x,w),
   % вычисляем начальные значения нейронов второго слоя
   l=w{1}*x' ;

   % вычисляем значения выхода сети
   l=ann_run_hopfield(l',w{2});

   retval=l;
endfunction

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function retval=ann_run_hopfield(l,w),
   MAX_ITERATION = 50 ;

   for i=1:MAX_ITERATION, 
      % вычисляем новое состояние
	  l_new=l*w ;
	  % обнуляем значения активности меньше нуля
	  l_new=(l_new+abs(l_new))/2.0 ; 

	  % проверяем изменения
	  if l == l_new , break; endif
	  l = l_new ;
   endfor

   retval=sign(l);

endfunction


