%!octave 
%
%       OS : GNU/Linux 3.12.0-1-ARCH 
% COMPILER : GNU Octave, version 3.8.0
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: data_load.m,v 1.1 2014/05/26 07:27:05 mechanoid Exp $


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function [ X s flst ]=data_load(d,gb),
   % список файлов с изображениями 
   flst=ls(d) ;

   % размер изображения (предполагаем, что все изображения однотипные )
   i=imfinfo(sprintf("%s/%s",d,flst(1,:))) ;
   s=[ i.Height  i.Width ] ;

   X=[] ;
   for i=1:size(flst,1), 
	  % выбираем файл 
	  f=flst(i,:) ;
	  % загружаем образ
	  xi=img_load(sprintf("%s/%s",d,f),gb) ;
	  
	  % save("-ascii",sprintf("result/%s.txt",f), "xi" );

	  X=[X;xi] ;
   endfor

   % добавляем сдвиг
   m=size(X,1) ;
   X=[ ones(m,1) X ] ;
   
endfunction

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% gb - порог яркости для grayscale [1:255]
function retval=img_load(f,gb),
   % загружаем изображение
   im=imread(f) ;
   % преобразуем изображение в матрицу [0,1]
   X=not( logical(sign(int16(im)-gb)+1 ) ) ;
   
   % преобразуем данные в [-1,1]
   X=X*2-1;

   retval=X(:)' ;
endfunction



